#!/usr/bin/env python3

import time
import socket
import subprocess
import sys

# ############################

def read_heading( ):  # Auslesen der Kuppelposition
  p = subprocess.Popen([r"./ScopeDome_GetRotEncoder.sh", "-h"], stdout=subprocess.PIPE)
  p.wait()
  out=p.stdout.read()
  print(out[-6:])
  return float(out[-6:])

# ############################
def RotCW( ):  # Rotate ClockWise
  p = subprocess.Popen([r"./ScopeDome_RotCW.sh", "-h"], stdout=subprocess.PIPE)
  p.wait()
  out=p.stdout.read()
  return 0

# ############################
def RotCCW( ):  # Rotate CounterClockWise
  p = subprocess.Popen([r"./ScopeDome_RotCCW.sh", "-h"], stdout=subprocess.PIPE)
  p.wait()
  out=p.stdout.read()
  return 0

# ############################
def RotStop( ):  # Rotate CounterClockWise
  p = subprocess.Popen([r"./ScopeDome_RotStop.sh", "-h"], stdout=subprocess.PIPE)
  p.wait()
  out=p.stdout.read()
  return 0

# ############################

from_winkel = read_heading()
to_winkel   = float(sys.argv[1]) % 360. # 1. Uebergabeparameter: Zielwinkel
diff_winkel = to_winkel-from_winkel
if (diff_winkel >  180.):
  diff_winkel -= 360.0
if (diff_winkel < -180.):
  diff_winkel += 360.0

diffabsold=1000.
diffabs=abs(diff_winkel)

if (diffabs>2.):
  if (diff_winkel > 0.):
    # fuer positiven Drehwinkel
    RotCW()
  else:
    # fuer negativen Drehwinkel
    RotCCW()

  cnt=1
  while 1==1 :
    from_winkel = read_heading()
    diff_winkel = to_winkel - from_winkel
    if (diff_winkel >  180.):
      diff_winkel -= 360.0
    if (diff_winkel < -180.):
      diff_winkel += 360.0
    diffabs     = abs(diff_winkel)
    if (diffabs>diffabsold):
      break
    if (diffabs < 2.):
      break
    if (cnt==1):
      diffabs1 = diffabs
    if (cnt==20):
      if ( abs(diffabs-diffabs1) < 2. ):
        print ('Err: drive blocked', '% 8.2f' % diff_winkel)
        break
      cnt=1
    cnt=cnt+1

    diffabsold=diffabs

  # Strom abschalten!
  RotStop()
